#!/usr/local/bin/perl
# O̍s𐧌邽߂̃TvXNvgłB
#
# (c)Copyright 1999,2000 Whitire Company

# Logfile name
$file = "./access.log";

# Lock type
#	0=No, 1=symlink, 2=open
$lock_type = 0;

# Lock file name
$lock_file = "./aclogs.lock";

# Max line
$max_line = 1000;

# Get current date/time
($sec, $min, $hour, $mday, $mon, $year) = localtime(time);
$year += 1900;
$mon++;

# Lock
if ($lock_type == 1) {
	&sym_lock;
}
elsif ($lock_type == 2) {
	&open_lock;
}

# Seek
open(IN, "$file");
@lines = <IN>;
@new = ();
close(IN);
$read_line = 1;
foreach $line (@lines) {
	if ($read_line < $max_line) {
		push(@new, $line);
	}
	$read_line++;
}
$date_time = "1#($ARGV[0])$year/$mon/$mday $hour:$min:$sec\t";
$agent = "2#$ENV{'HTTP_USER_AGENT'}\t";
$reffer = "3#$ENV{'HTTP_REFERER'}\t";
$addr = "4#$ENV{'REMOTE_HOST'}($ENV{'REMOTE_ADDR'})\n";
$logs = "$date_time$agent$reffer$addr";
unshift(@new, $logs);

# Output
open(OUT, "> $file");
print OUT @new;
close(OUT);

# Unlock
if (-e $lock_file) {
	unlink($lock_file);
}

exit 0;

#-----
# symlink lock
sub sym_lock {
	local($retry) = 5;
	while (!symlink(".", $lock_file)) {
		if (--$retry <= 0) {
			exit;
		}
		sleep(1);
	}
}

#-----
# open lock
sub open_lock {
	local($lock_flag) = 0;
	local($retry) = 0;
	while ($retry < 5) {
		if (-e $lock_file) {
			sleep(1);
		}
		else {
			open(LOCK, "> $lock_file");
			close(LOCK);
			$retry = 5;
			$lock_flag = 1;
		}
		$retry++;
	}
	if ($lock_flag == 0) {
		exit;
	}
}
